%bcond_without perl_Test2_Suite_enables_extra_test
%bcond_without perl_Test2_Suite_enables_unicode

Name:           perl-Test2-Suite
Version:        0.000155
Release:    2%{?dist}
Summary:        Set of tools built upon the Test2 framework
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Test2-Suite
Source0:        https://cpan.metacpan.org/authors/id/E/EX/EXODIST/Test2-Suite-%{version}.tar.gz
Patch0:         Test2-Suite-0.000140-add_perl.patch
BuildArch:      noarch
BuildRequires:  coreutils
BuildRequires:  make
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(B)
BuildRequires:  perl(base)
BuildRequires:  perl(Carp)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(Exporter)
BuildRequires:  perl(File::Spec)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(List::Util)
BuildRequires:  perl(overload)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Term::Table) >= 0.013
BuildRequires:  perl(Term::Table::Cell)
BuildRequires:  perl(Term::Table::LineBreak)
BuildRequires:  perl(Term::Table::Util)
BuildRequires:  perl(Test2::API) >= 1.302176
BuildRequires:  perl(Test2::API::Context)
BuildRequires:  perl(Test2::Event)
BuildRequires:  perl(Test2::Event::Exception)
BuildRequires:  perl(Test2::Event::Note)
BuildRequires:  perl(Test2::Event::Skip)
BuildRequires:  perl(Test2::EventFacet)
BuildRequires:  perl(Test2::EventFacet::Info::Table)
BuildRequires:  perl(Test2::EventFacet::Trace)
BuildRequires:  perl(Test2::Hub::Interceptor)
BuildRequires:  perl(Test2::Hub::Subtest)
BuildRequires:  perl(Test2::IPC)
BuildRequires:  perl(Test2::Tools::Tiny)
BuildRequires:  perl(Test2::Util)
BuildRequires:  perl(Test2::Util::HashBase)
BuildRequires:  perl(Test2::Util::Trace)
BuildRequires:  perl(threads)
BuildRequires:  perl(Time::HiRes)
BuildRequires:  perl(utf8)
BuildRequires:  perl(vars)
BuildRequires:  perl(Sub::Util)
%if %{with perl_Test2_Suite_enables_unicode}
BuildRequires:  perl(Unicode::GCString)
%endif
BuildRequires:  perl(IO::Handle)
%if %{with perl_Test2_Suite_enables_extra_test}
BuildRequires:  perl(JSON::MaybeXS)
%endif
BuildRequires:  perl(PerlIO)
BuildRequires:  perl(Test2::EventFacet::Assert)
BuildRequires:  perl(Test2::Formatter::TAP)
Requires:       perl(Data::Dumper)
Suggests:       perl(Sub::Util)
Requires:       perl(Term::Table) >= 0.013
Requires:       perl(Test2::API) >= 1.302176
Requires:       perl(Test2::Event)
Requires:       perl(Test2::Event::Note)
Requires:       perl(Test2::Event::Skip)
Requires:       perl(Test2::EventFacet)
Requires:       perl(threads)
Requires:       perl(utf8)
Recommends:     perl(Module::Pluggable) >= 2.7
%if %{with perl_Test2_Suite_enables_unicode}
Recommends:     perl(Unicode::GCString)
%endif
Provides:       perl-Test2-AsyncSubtest = %{version}-%{release}
Provides:       perl-Test2-Workflow = %{version}-%{release}
Provides:       bundled(Importer) = 0.026
Provides:       bundled(Scope::Guard) = 0.21
Provides:       bundled(Sub::Info) = 0.002

%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Term::Table|Test2::API)\\)$
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(MyTest::Target\\)$
%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}

%description
Rich set of tools, plugins, bundles, etc. built upon the Test2 testing
library. If you are interested in writing Perl tests this is the distribution
for you.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{version}-%{release}
Requires:       perl-Test-Harness
Requires:       perl(JSON::MaybeXS)
Requires:       perl(Test::Compile) >= 1.1.0
Recommends:     perl(Module::Pluggable) >= 2.7
Recommends:     perl(Unicode::GCString)

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%prep
%setup -q -n Test2-Suite-%{version}
%patch 0 -p1
for F in `find . -type f -name '*.t'`; do
    perl -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!\s*perl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
cd %{_libexecdir}/%{name} && exec prove -r -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
unset AUTHOR_TESTING
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%changelog
* Wed Jun 11 2025 bbrucezhang <bbrucezhang@tencent.com> - 0.000155-2
- Rebuilt for loongarch64

* Thu Jul 04 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.000155-1
- initial build
